'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactModal = require('react-modal');

var _reactModal2 = _interopRequireDefault(_reactModal);

var _fuzzaldrinPlus = require('fuzzaldrin-plus');

var _fuzzaldrinPlus2 = _interopRequireDefault(_fuzzaldrinPlus);

var _downshift = require('downshift');

var _downshift2 = _interopRequireDefault(_downshift);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// 🔮 might not want to rely on a modal


var CommandPalette = function (_Component) {
  _inherits(CommandPalette, _Component);

  function CommandPalette() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, CommandPalette);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = CommandPalette.__proto__ || Object.getPrototypeOf(CommandPalette)).call.apply(_ref, [this].concat(args))), _this), _this.onChange = function (_ref2) {
      var action = _ref2.action;

      _this.props.dispatchAction(action);
      _this.props.hideCommandPalette();
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(CommandPalette, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var placeholder = 'Type ? to see available commands';
      return _react2.default.createElement(
        _reactModal2.default,
        {
          style: { overlay: { zIndex: 20 } },
          isOpen: this.props.isOpen,
          onRequestClose: this.props.hideCommandPalette,
          onAfterOpen: function onAfterOpen() {
            return _this2.input.focus();
          }
        },
        _react2.default.createElement(
          _downshift2.default,
          {
            isOpen: this.props.isOpen,
            onChange: this.onChange,
            defaultInputValue: '',
            defaultHighlightedIndex: 0,
            itemToString: function itemToString(i) {
              return i ? i.copy : '';
            }
          },
          function (_ref3) {
            var getInputProps = _ref3.getInputProps,
                getItemProps = _ref3.getItemProps,
                getLabelProps = _ref3.getLabelProps,
                highlightedIndex = _ref3.highlightedIndex,
                inputValue = _ref3.inputValue,
                isOpen = _ref3.isOpen,
                selectedItem = _ref3.selectedItem;

            return _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement('label', getLabelProps()),
              _react2.default.createElement('input', _extends({
                autoFocus: true,
                ref: function ref(input) {
                  _this2.input = input;
                }
              }, getInputProps({
                placeholder: placeholder
              }))),
              isOpen ? _react2.default.createElement(
                'div',
                null,
                _fuzzaldrinPlus2.default.filter(_this2.props.commands, inputValue, { key: 'copy' }).map(function (item, index) {
                  return _react2.default.createElement(
                    'div',
                    getItemProps({
                      key: item.action,
                      index: index,
                      item: item,
                      style: {
                        backgroundColor: highlightedIndex === index ? 'lightgray' : 'white',
                        fontWeight: selectedItem === item.copy ? 'bold' : 'normal'
                      }
                    }),
                    _react2.default.createElement('span', {
                      dangerouslySetInnerHTML: {
                        __html: _fuzzaldrinPlus2.default.wrap(item.copy, inputValue)
                      }
                    })
                  );
                })
              ) : null
            );
          }
        )
      );
    }
  }]);

  return CommandPalette;
}(_react.Component);

CommandPalette.propTypes = {
  commands: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    action: _propTypes2.default.string.isRequired,
    copy: _propTypes2.default.string.isRequired
  }).isRequired).isRequired,
  dispatchAction: _propTypes2.default.func.isRequired
};

exports.default = CommandPalette;

// export default connect(null, dispatch => ({
//   dispatchAction: type => dispatch({ type }),
// }))(CommandPalette);